Hero = Core.class(Sprite)

function Hero:init()

	local pack = TexturePack.new("gfx/hero.txt", "gfx/hero.png")
	
	self.animMoving = {
		Bitmap.new(pack:getTextureRegion("hero_07.png")),
		Bitmap.new(pack:getTextureRegion("hero_08.png")),
		Bitmap.new(pack:getTextureRegion("hero_09.png")),
	}
	
	self.animStoped = Bitmap.new(pack:getTextureRegion("hero_08.png"))
	self.animJumping = Bitmap.new(pack:getTextureRegion("hero_07.png"))
	
	self.body = world:createBody {type = b2.DYNAMIC_BODY, fixedRotation = true}
	self.body.name = "hero"
	local shape = b2.PolygonShape.new()
	shape:setAsBox(20,32,32,32,0)
	
	self.body:createFixture {shape = shape, density = 1, restitution = 0.2, friction = 0.3}
	
	self.frame = 1
	self:addChild(self.animStoped)
	self.subframe = 0
	self.onGround = false
	self.moving = false
	self.jumping = false
	
	self:addEventListener(Event.ENTER_FRAME, self.animate, self)
	self:addEventListener(Event.MOUSE_DOWN, self.onMouseDown, self)
end

function Hero:setX(x)
	self:set("x", x)
	self.body:setPosition(self:getX(), self:getY())
end

function Hero:setY(y)
	self:set("y", y)
	self.body:setPosition(self:getX(), self:getY())
end

function Hero:animate()
	--print(self.moving)

	if self.jumping then
		self:removeChildAt(1)
		self:addChild(self.animJumping)
		self.frame = 1
		self.subframe = 0
	elseif self.moving then 	
	
		self.subframe = self.subframe + 1

		if self.subframe > 2 then
			self:removeChildAt(1)
			
			self.frame = self.frame + 1
			if self.frame > #self.animMoving then
				self.frame = 1
			end

			self:addChild(self.animMoving[self.frame])
			
			self.subframe = 0
		end
	else
		self:removeChildAt(1)
		self:addChild(self.animStoped)
		self.frame = 1
		self.subframe = 0
	end	
		
	self:setPosition(self.body:getPosition())	
end

function Hero:onMouseDown(event)
	if self.onGround then
		self.jumping = true;
		self.body:setLinearVelocity(0, -10);
	end
end